SystemOrganization addCategory: #'LizViz-Traits'!

Trait named: #TZzAddFirstOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddFirstOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 18:43:55.366'!
add: anItemValue
	
	^ self addFirst: anItemValue! !

!TZzAddFirstOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:42:41.905'!
addFirst: anItemValue
	
	| newItem |
	newItem := self createItem
		nextItem: self firstItem;
		previousItem: nil;
		value: anItemValue.
	self
		firstItem: newItem;
		itemAddedFirst: newItem.
	self firstItem nextItem ifNotNilDo: [:item | 
		(item respondsTo: #previousItem) ifTrue: [item previousItem: newItem]].
	^ newItem! !

!TZzAddFirstOperation methodsFor: 'signals' stamp: 'ls 6/10/2013 21:07:23.471'!
itemAddedFirst: anItem
	
	self log: (ZzVisualizationEvent new
		type: #itemAddedFirst:;
		parameter1: anItem).! !

Trait named: #TZzAddLastOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddLastOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:45:05.058'!
addLast: anItemValue
	
	| lastItem currentItem newItem |
	lastItem := self firstItem.
	lastItem ifNil: [
		newItem := self createItem
			nextItem: nil;
			previousItem: nil;
			value: anItemValue.
		self firstItem: newItem.
		^ newItem].
	
	currentItem := lastItem.
	[currentItem isNil not]
		whileTrue: [
			lastItem := currentItem.
			currentItem := currentItem nextItem].
	
	newItem := self createItem
		nextItem: nil;
		previousItem: lastItem;
		value: anItemValue.
	
	lastItem nextItem: newItem.
	^ newItem! !

Trait named: #TZzAddOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:45:12.668'!
add: anItemValue at: anIndex
	
	| linkingItem newItem |
	self firstItem ifNil: [^ self].
	
	linkingItem := self firstItem.
	(anIndex - 1 > 0 and: [linkingItem nextItem isNil not])
		whileTrue: [linkingItem := linkingItem nextItem].
	
	(anIndex - 1 > 0) ifTrue: [self error: 'index out of bounds'].
	
	newItem := self createItem
		nextItem: linkingItem nextItem;
		previousItem: linkingItem;
		value: anItemValue.
	"newItem previousItem: linkingItem."
	linkingItem nextItem previousItem: newItem.
	"newItem nextItem: linkingItem nextItem."
	linkingItem nextItem: newItem.
	^ newItem! !

Trait named: #TZzIsEmptyOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzIsEmptyOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 19:48:15.168'!
isEmpty
	
	^ self firstItem isNil! !

Trait named: #TZzPopOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzPopOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 12:55:27.487'!
pop

	| item |
	item := self firstItem.
	item isNil ifTrue: [^ nil].
	self firstItem: item nextItem.
	^ item! !

Trait named: #TZzPushOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzPushOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:48:36.106'!
push: aValue

	| newItem |
	newItem := self createItem
		nextItem: self firstItem;
		value: aValue.
	self firstItem: newItem.! !

Trait named: #TZzRemoveFirstOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzRemoveFirstOperation methodsFor: 'signals' stamp: 'or 6/7/2013 19:12:00.953'!
itemRemoved: anItem

	self emit.! !

!TZzRemoveFirstOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 12:57:31.478'!
removeFirst
	
	| first next |
	first := self firstItem.
	first ifNil: [^ self].
	self itemRemoved: first.
	next := first nextItem.
	self firstItem: next.
	(next respondsTo: #previousItem) ifTrue: [ next previousItem: nil].! !

Trait named: #TZzRemoveLastOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzRemoveLastOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:15:41.787'!
removeLast
	
	| linkageItem currentItem |
	linkageItem := self firstItem.
	linkageItem ifNil: [^ self].
	
	currentItem := linkageItem.
	[currentItem isNil not]
		whileTrue: [
			linkageItem := currentItem.
			currentItem := currentItem nextItem].
	linkageItem nextItem: nil.! !

Trait named: #TZzSizeOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzSizeOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:17:03.242'!
size
	
	| size nextItem |
	size := 0.
	nextItem := self firstItem.
	[nextItem isNil not] whileTrue: 
		[size := size + 1.
		nextItem := nextItem nextItem].
	^ size! !
